codeforces gym100418J

题目简述

给定N 求1到N中有多少个幸运数字 幸运数字的定义为 这个数能被它二进制表示下1的个数整除

其中(1 ≤ N ≤ 1019)

--------------------------------------------------------------------------------------------------------------------------------

第二道数位DP题 在这里感谢一下 Gatevin 学长的讲解帮我克服了对数位DP的畏惧

这题我的做法和前面我写的那篇 windy数  的题解的思路差不多的

先从最低位到最高位处理一下只有当前位(当前位之前假设都是前导0)有限定的时候的方案数

( f数组的四位分别是 当前位是哪一位 这一位是0还是1 现在的集合中有几个1 现在的集合中的数modx的值)

然后再从最高位到最低位扫一遍即可

#include <bits/stdc++.h>
using namespace std;
const int N=70;
unsigned long long n;
int lim[N];
unsigned long long f[N][2][N][N];
int top;
void prepare(int x)
{
    memset(f,0,sizeof(f));
    f[0][0][0][0]=1;
    f[0][1][1][1%x]=1;
    for(int i=0;i<top-1;++i)
        for(int j=0;j<=x;++j)
            for(int k=0;k<x;++k)
            {
                f[i+1][0][j][k]+=f[i][0][j][k];
                f[i+1][0][j][k]+=f[i][1][j][k];
                f[i+1][1][j+1][(k+(1ULL<<i+1))%x]+=f[i][0][j][k];
                f[i+1][1][j+1][(k+(1ULL<<i+1))%x]+=f[i][1][j][k];
            }
}
unsigned long long check(int x)
{
    unsigned long long re=0;
    int tmp=0,cnt=0;
    for(int i=top-1;i>=0;--i)
        if(lim[i])
        {
            if(x-cnt>=0)
                re+=f[i][0][x-cnt][(x-tmp)%x];
            tmp=((1ULL<<i)+tmp)%x;
            ++cnt;
        }
    return re+(cnt==x&&!tmp);
}
int main()
{
    scanf("%llu",&n);
    while(n)
    {
        lim[top++]=n&1;
        n>>=1;
    }
    unsigned long long ans=0;
    for(int i=1;i<=top;++i)
    {
        prepare(i);
        ans+=check(i);
    }
    printf("%llu",ans);
    return 0;
}
时间: 2024-10-11 10:34:55

codeforces gym100418J的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ